import { CommonToken, CommonTokenStream, ErrorListener as ANTLRErrorListener, ParseTree, Recognizer, TerminalNode, Token } from 'antlr4';
import { MergeClauseContext } from '../generated-parser/CypherCmdParser';
export declare class FormatterErrorsListener implements ANTLRErrorListener<CommonToken> {
    syntaxError<T extends Token>(_r: Recognizer<CommonToken>, offendingSymbol: T, line: number, column: number): void;
    reportAmbiguity(): void;
    reportAttemptingFullContext(): void;
    reportContextSensitivity(): void;
}
export declare function handleMergeClause(ctx: MergeClauseContext, visit: (node: ParseTree) => void): void;
export declare function wantsToBeUpperCase(node: TerminalNode): boolean;
export declare function wantsSpaceBefore(node: TerminalNode): boolean;
export declare function wantsSpaceAfter(node: TerminalNode): boolean;
export declare function isComment(token: Token): boolean;
export declare function getParseTreeAndTokens(query: string): {
    tree: import("../generated-parser/CypherCmdParser").StatementsOrCommandsContext;
    tokens: CommonTokenStream;
};
export declare function findTargetToken(tokens: Token[], cursorPosition: number): Token | false;
